Skip to main content

Overview

Seam provides a universal API to connect and control many brands of locks, including Igloohome. This guide provides a rapid introduction to connecting and controlling your Igloohome locks using the Seam API. To learn more about other device brands supported by the Seam API, such as Yale, Schlage, and August, head over to our integration page.

1 — Install Seam SDK

Seam provides client libraries for many languages, such as JavaScript, Python, Ruby, PHP, and others, as well as a Postman collection and OpenAPI spec.
npm i seam
Once installed, sign-up for Seam to get your API key, and export it as an environment variable:
$ export SEAM_API_KEY=seam_test2ZTo_0mEYQW2TvNDCxG5Atpj85Ffw
This guide uses a Sandbox Workspace. Only virtual devices can be connected. If you need to connect a real Igloohome device, use a non-sandbox workspace and API key.
To control your Igloohome locks via the Seam API, you must first authorize your Seam workspace against your Igloohome account. To do so, Seam provides Connect Webviews: pre-built UX flows that walk you through authorizing your application to control your Igloohome devices.

Request a Connect Webview

import { Seam } from 'seam'

const seam = new Seam()

const { connect_webview: connectWebview } = await seam.connectWebviews.create({
accepted_providers: ['igloohome'],
})

console.log(connectWebview.login_successful) // false

// Send the webview URL to your user
console.log(connectWebview.url)

Authorize Your Workspace

Navigate to the URL returned by the Webview object. Since you are using a sandbox workspace, complete the login flow by entering the Igloohome sandbox test accounts credentials below: Confirm the Connect Webview was successful by querying its status:
const updatedWebview = await seam.connectWebviews.get(
  connectWebview.connect_webview_id,
)

console.log(updatedWebview.login_successful) // true

3 — Retrieve Igloohome Devices

After an Igloohome account is linked with Seam, you can retrieve devices for this Igloohome account. The Seam API exposes most of the device’s properties such as battery level.
const allLocks = await seam.locks.list()

const someLock = allLocks[0]

console.log(someLock.properties.online) // true
console.log(someLock.properties.locked) // true

console.log(someLock)
/_
{
device_id: '60d0f1b6-26ae-4366-8d1b-d20ad0d6a62e',
device_type: 'igloohome_lock',
capabilities_supported: [ 'access_code', 'lock' ],
properties: {
locked: false,
online: true,
manufacturer: 'igloohome',
battery_level: 0.86,
igloohome_metadata: { device_id: '545636388', device_name: 'Office Lock' },
max_active_codes_supported: 100,
supported_code_lengths: [ 6 ],
name: 'Office Lock'
},
location: null,
connected_account_id: '32e92b46-7978-4d48-a3e7-9b04662151b3',
workspace_id: 'd7418ff3-a476-4f48-9a4b-211d1d21a03d',
created_at: '2023-02-11T00:46:12.940Z',
errors: [],
warnings: []
}
_/

4 — Locking & Unlocking a Door

Next, you can perform the basic action of locking and unlocking a door.
POST /locks/lock_door See the API Reference for details.

Unlock a door

POST https://connect.getseam.com/locks/unlock_door

Request Body

NameTypeDescription
device_idString
// lock the door
await seam.locks.lockDoor(someLock.device_id)
const updatedLock = await seam.locks.get(someLock.device_id)
console.log(updatedLock.properties.locked) // true

// unlock the door
await seam.locks.unlockDoor(someLock.device_id)
updatedLock = await seam.locks.get(someLock.device_id)
console.log(updatedLock.properties.locked) // false

5 — Setting Access Code on Igloohome Lock

Most Igloohome locks come with a keypad built-in to program access codes. These codes can then be entered to unlock a Igloohome lock. The Seam API makes it easy to program both ongoing codes and timebound codes on an Igloohome lock. You can find out more about Igloohome lock access code in our core concept section on access codes.
Igloohome pins have to be 4-6 digits long, and for time bound access codes, start date can’t be on the past.
// create an ongoing code
await seam.accessCodes.create({
  device_id: someLock.device_id,
  code: '123456',
  name: 'Personal Access Code',
})

// create a timebound code
await seam.accessCodes.create({
device_id: someLock.device_id,
code: '888888',
name: 'My Temp Access Code',
starts_at: '2028-11-12T19:23:42+0000',
ends_at: '2028-11-13T19:23:42+0000',
})

// use a device_id as the "device_id" parameter
await seam.accessCodes.list({
device_id: someLock.device_id,
})

Next Steps

Now that you’ve completed this guide, you can try to connect a real Igloohome device. To do so, make sure to switch to a non-sandbox workspace and API key as real devices cannot be connected to sandbox workspaces. In addition, if you’d like to explore other aspects of Seam, here is a list of helpful resources: If you have any questions or want to report an issue, email us at support@seam.co.